<template>
  <div class="payslip">
    <div class="modal" v-bind:class="{ active: isActive }">
      <span @click="closePayslip" class="modal-overlay" aria-label="Close"></span>
      <div class="modal-container" id ="modalContainer">
        <div class="modal-header">
          <div class="heading1" >
           <a v-on:click="closePayslip" class="btn btn-clear float-right close-btn" aria-label="Close"></a>
            <div class="modal-title h5">{{data.employee_name}} </div>
            <div class="modal-title small_text1">{{employee.position}}</div>
          </div>
        </div>
        <div class="modal-body">
          <div class="modal_content" id="content">
            <div class="columns">
              <div class="column package-section top-actions">
                <span class="payslip-heading">Payslip</span>
                <div>
                  <span class="payslip-label">Current Year: </span>
                  <span>
                    <select v-model="selectedYear">
                      <option v-for="year in payslipYear" :value="year" :key="year">{{year}}</option>
                    </select>
                  </span>
                </div>
                <div>
                  <span>Current Month: </span>
                  <span>
                    <select v-model="selectedMonth">
                      <option v-for="(month, index) in payslipMonth" :value="index" :key="index">{{month}}</option>
                    </select>
                  </span>
                </div>
                <div>
                  <span>Payrun ID: </span><span>{{data.payrun_id}}</span>
                </div>
                <div>
                  <span>Net Pay: </span><span>{{formatNumber(data.net_pay)}}</span>
                </div>
              </div>
            </div>
            <div class="columns">
              <div class="column col-6 package-section top-actions">
                <span class="payslip-heading">Earnings</span>
                <div>
                  <div ref="earning" v-for="(earning, index) in employeePackage.earnings" class="columns show_div" v-bind:class="{ 'grey_div': isEven(index) }" :key="index">
                    <div class="column col6 show_label">{{earning.type}}</div>
                    <div class="column col6 div-reset">
                      <span class="float-right">{{formatNumber(earning.rate)}}</span>
                    </div>
                  </div>
                </div>
              </div>
              <div class="column col-6 package-section top-actions">
                <span class="payslip-heading">Deductions</span>
                <div>
                  <div v-for="(deduction, index) in employeePackage.deductions" class="columns show_div" v-bind:class="{ 'grey_div': isEven(index) }" :key="index">
                    <div class="column col6 show_label">{{deduction.type}}</div>
                    <div class="column col6 div-reset">
                      <span class="float-right">{{formatNumber(deduction.rate, true)}}</span>
                    </div>
                  </div>
                </div>
              </div>
            </div>
            <div class="columns">
              <div class="column package-section top-actions col6 show_field">
                <span class="payslip-heading">Total</span>
                <span class="float-right payslip-heading">{{formatNumber(data.earnings)}}</span>
              </div>
              <span class="column package-section top-actions col6 show_field">
                <span class="payslip-heading">Total</span>
                <span class="float-right payslip-heading">{{formatNumber(data.deductions, true)}}</span>
              </span>
            </div>
            <div class="columns">
              <div class="column package-section top-actions">
                <span class="payslip-action" @click="downloadPdf">
                  <img src="images/icons/download_blue_bg.svg" alt="Download icon" class=""/> 
                  <span>Download</span> 
                </span>
                <span class="payslip-action">
                  <img src="images/icons/share_blue_bg.svg" alt="Share icon" class=""/>
                  <span>Share</span>
                </span>
                <span class="payslip-action" @click="printSlip">
                  <img src="images/icons/print_blue_bg.svg" alt="Download icon" class=""/>
                  <span>Print</span>
                </span>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import axios from "axios";
import jsPDF from "jspdf";
import 'jspdf-autotable';

export default {
  props:['payslip_data', 'display_payslip'],
  data() {
    return {
      isActive: this.display_payslip,
      data: this.payslip_data,
      employee: [],
      employeePackage: [],
      payslipMonth: [],
      payslipYear: [],
      selectedYear: 0,
      selectedMonth: ""
    }
  },
  methods: {
    addAddress(pdf, setup) {
      let marginTop = 1.15;
      // let y = setup.pageMargin + setup.imageHeight + (marginTop * 2);

      pdf.setFontSize(11)
      pdf.text('3 Olaletan Street,', setup.pageMargin, marginTop);
      pdf.text('Oniru, VI Extension,', setup.pageMargin, marginTop + 0.25);
      pdf.text('Lagos, Nigeria', setup.pageMargin, marginTop + 0.5);
    },
    addDeductionsToSlip(pdf, setup) {
      let finalY = 3.5;
      let deductions = this.employeePackage.deductions;
      let deductionArray = [];
      for(const deduction in deductions) {
        deductionArray.push([deductions[deduction].type, this.formatNumber(deductions[deduction].rate)])
      }
      
      pdf.text("Deductions", setup.pageMargin + 4, finalY);
      pdf.autoTable({
        startY: finalY + 0.3,
        margin: { left: setup.pageMargin + 3.9 },
        styles: { cellWidth: 1.5, cellPadding: {left: 0.1} },
        tableWidth: 'wrap',
        body: deductionArray,
      });
    },
    addEmployeeDetail(pdf, setup ) {
      let marginTop =  2.8;
      let marginLeft = 4.1;
      let name = this.data.employee_name;
      let role = this.employee.position;
      // let package = `Package: ${employeeDetails.package}`;
      let payrunId = this.data.payrun_id;
      let netPay = this.formatNumber(this.data.net_pay);
      pdf.setFontSize(10)

      pdf.setFontType("bold");
      pdf.text('Employee: ', setup.pageMargin, marginTop);
      pdf.setFontType("normal");
      pdf.text(name, setup.pageMargin + 0.75, marginTop);

      pdf.setFontType("bold");
      pdf.text('Payrun ID: ', marginLeft + 0.3, marginTop);
      pdf.setFontType("normal");
      pdf.text(payrunId, marginLeft + 1.05, marginTop);

      pdf.setFontType("bold");
      pdf.text('Role: ', setup.pageMargin, marginTop + 0.25);
      pdf.setFontType("normal");
      pdf.text(role, setup.pageMargin + 0.4, marginTop + 0.25);

      pdf.setFontType("bold");
      pdf.text('Net Pay: ', marginLeft + 0.3, marginTop + 0.25);
      pdf.setFontType("normal");
      pdf.text(netPay, marginLeft + 0.9, marginTop + 0.25);
      // pdf.text(package, pageMargin, marginTop + 0.4);
    },
    addEarningsToSlip(pdf, setup) {
      let finalY = 3.5;
      let earnings = this.employeePackage.earnings;
      let earningArray = [];
      for(const earning in earnings) {
        earningArray.push([earnings[earning].type, this.formatNumber(earnings[earning].rate)])
      }
      
      pdf.setFontType("bold");
      pdf.text("Earnings", setup.pageMargin, finalY);
      pdf.autoTable({
        startY: finalY + 0.3,
        margin: { left: setup.pageMargin - 0.1 },
        styles: { cellWidth: 1.5, cellPadding: {left: 0.1} },
        tableWidth: 'wrap',
        body: earningArray,
      });
    },
    addLogo(pdf, setup) {
      let img = new Image();
      let imageUrl = 'images/icons/lopworks_logo.png';
      let imageWidth = 1.57; // inches
      let imageHeight = 0.41; // inches

      img.src = imageUrl;
      pdf.addImage(img, 'PNG', setup.pageMargin, setup.pageMargin, imageWidth, imageHeight);
    },
    addTitle(pdf) {
      let marginTop = 2.3;
      let marginLeft = 2.3;
      let months = ["January", "February", "March", "April", "May", "June", 
        "July", "August", "September", "October", "November", "December"]
      // fix width for longer month
      let title = `PAYSLIP FOR THE MONTH OF ${months[this.selectedMonth].toUpperCase()}, ${this.selectedYear}`;
      pdf.setFontSize(12);
      pdf.setFontType("bold");
      pdf.text(title, marginLeft, marginTop);
      
    },
    addTotal(pdf, setup) {
      console.log(pdf);
      let marginTop = pdf.previousAutoTable.finalY + 1.2;
      // let marginTop = 2.3; 
      let marginLeft = 1.9;
      let totalEarnings = this.formatNumber(this.data.earnings)
      let totalDeductions = this.formatNumber(this.data.deductions, true)
      pdf.text("Total", setup.pageMargin, marginTop + 0.05);
      pdf.text(totalEarnings, marginLeft, marginTop + 0.05);
      pdf.text("Total", marginLeft + 2.5, marginTop + 0.05);
      pdf.text(totalDeductions, marginLeft + 3.9, marginTop + 0.05);
    },
    closePayslip(event) {
      event.preventDefault()
      this.isActive=false
      this.$emit("close");
    },
    downloadPdf() {
      let pdf = this.generatePdf();
      let filename = this.data.employee_name.replace(/\s/g, '_');
      pdf.save(`${filename}.pdf`);
    },
    formatNumber(number, signed=false) {
      number = number.charAt(0) === '-' ? number.substring(1) : number;
      // let result = new Intl.NumberFormat().format(number)
      let result = new Intl.NumberFormat('en-US', {
        style: 'currency',
        currency: 'NGN',
        minimumFractionDigits: 2
      }).format(number);
      return (signed ? `- ${result}` : `${result}`)
    },
    generatePdf() {
      let pdf = new jsPDF('p', 'in', 'a4');
      let pdfSetup = {
        pageMargin: 0.4, // inches
      }

      this.setupDocument(pdf)
      this.addLogo(pdf, pdfSetup)
      this.addAddress(pdf, pdfSetup)
      this.addTitle(pdf)
      this.addEmployeeDetail(pdf, pdfSetup)
      this.addEarningsToSlip(pdf, pdfSetup)
      this.addDeductionsToSlip(pdf, pdfSetup)
      this.addTotal(pdf, pdfSetup)

      return pdf;
    },
    getEmployee(){
      let self = this;
      axios.get("/api/employees/"+this.data.employee_id).then(function(response){
        self.employee = response.data
      })
      .catch(function (error) {
        console.log(error)
      })
    },
    getEndDate() {
      let end_date = new Date(this.selectedYear, this.selectedMonth + 1, 0)
      return new Date(end_date.getTime() - end_date.getTimezoneOffset() * 60000).toISOString().substring(0, 10)
    },
    getStartDate() {
      let start_date = new Date(this.selectedYear, this.selectedMonth, 1)
      return new Date(start_date.getTime() - start_date.getTimezoneOffset() * 60000).toISOString().substring(0, 10)
    },
    getPackage(){
      var self = this;
      axios.get("/api/packages/"+this.data.employee_id, {
        params: { start_date: this.getStartDate(), end_date: this.getEndDate() }
      }).then(function(response){
        self.employeePackage = response.data
      }).catch(function (error) {
        console.log(error)
      })
    },
    isEven(index) {
      return index % 2
    },
    populateMonth() {
      let today = new Date()
      let currentYear = today.getFullYear()
      let currentMonth = today.getMonth()
      let months = ["January", "February", "March", "April", "May", "June", 
        "July", "August", "September", "October", "November", "December"]
      
      if( this.selectedYear < currentYear ) {
        this.payslipMonth = months
        this.selectedMonth = 0
      } else {
        this.payslipMonth = months.slice(0, currentMonth + 1)
        this.selectedMonth = currentMonth
      }
    },
    populateYear() {
      let currentYear = new Date().getFullYear()
      this.selectedYear = currentYear
      this.payslipYear.push(currentYear)
      for (let i = 0; i < 5; i++){
        this.payslipYear.push(--currentYear)
      }
    },
    printSlip() {
      let pdf = this.generatePdf();
      pdf.output('dataurlnewwindow')
    },
    setupDocument(pdf) {
      // pdf.setFont('courier')
      pdf.setFontType('normal')
    }
  },
  watch: {
    selectedYear() {
      this.populateMonth()
      
    },
    selectedMonth() {
      this.getPackage()
    }
  },
  mounted() {
    this.getEmployee()
    this.populateYear()
    this.populateMonth()
    this.getPackage() 
  }
}
</script>
<style scoped>
.payslip-heading {
  font-size: 14px;
  line-height: 1.21;
  font-weight: bold;
  margin-bottom: 10px;
}
.payslip-label {
  font-weight: 500;
}
.payslip-action{
  cursor: pointer;
  margin-right: 20px;
  text-transform: uppercase
}
.payslip-action img{
  vertical-align: middle;
  width: 20px;
  height: 20px;
}
.div-reset {
  padding-right: 0 !important
}
</style>
